/*
**	fft_czt.h -- header file for fft.c and czt.c
**
**	Public domain by MIYASAKA Masaru <alkaid@coral.ocn.ne.jp> (Nov 29, 2002)
**
**	[TAB4]
*/

#ifndef	FFT_CZT_H
#define	FFT_CZT_H

	/* ^̒` - float/double ̌^̈Ⴂɂ */
	/* fft.c / czt.c ̎Op֐\̌vZ@኱ςĂ܂ */
#ifdef	REAL_IS_DOUBLE
typedef double REAL;
#else
typedef float  REAL;
#endif

	/* FFTvZp \ێ\ */
typedef struct {
	int  samples;		/* W{_̐( 4ȏ 2̐Ɍ) */
	int  *bitrev;		/* rbg]\ - vf(samples) */
	REAL *sintbl;		/* Op֐\ - vf(samples*3/4) */
} fft_struct;

	/* CZTvZp \ێ\ */
typedef struct {
	fft_struct fft;		/*  FFTvZp */
	int  samples;		/* W{_̐ */
	int  samples_out;	/* o͂W{_̐ */
	int  samples_ex;	/* 2̐ŁA(samples + samples_out) <= samples_ex
						 * łŏ̐ */
	REAL *wr, *wi;		/* d݃f[^ - vf(samples) */
	REAL *vr, *vi;		/* CpXf[^ - vf(samples_ex) */
	REAL *tr, *ti;		/* Ɨp̈ - vf(samples_ex) */
} czt_struct;

	/* fft.c */
int fft_init(fft_struct *fftp, int n);
void fft_end(fft_struct *fftp);
void fft(fft_struct *fftp, int inv, REAL re[], REAL im[]);

	/* czt.c */
int czt_init(czt_struct *cztp, int n, int no);
void czt_end(czt_struct *cztp);
void czt(czt_struct *cztp, int inv, REAL re[], REAL im[]);

#endif	/* FFT_CZT_H */
